#ifndef _SAVEBLOCK_CLASS_LOADED
#define _SAVEBLOCK_CLASS_LOADED 1

#include <string.h>
#include <semaphore.h>

class SaveBlock
{
public:
	unsigned char *Buffer;
	size_t         BufferSize;
	size_t         BufferFilled;
	unsigned char *BufferSavePosition;
	bool           b_FinalBlock;
	int            m_i_Level;
	int            m_i_AnalyzeResult;


	SaveBlock(size_t size);
	~SaveBlock();
	
	int WriteBlock(int OutFileHandle);
	bool IsFinalBlock();
	void SetFinalBlock();


} ; // SaveBlock


#define SAVEBLOCKARRAYSIZE 16

class SaveBlockArray
{
public:
   
   SaveBlockArray();
   ~SaveBlockArray();
   
   SaveBlock *GetNextRecordBlock();
   SaveBlock *GetNextWriteBlock();
   void ReleaseRecordBlock();
   void Initialize();
 
private:
   int NextRecordBlock;
   int NextWriteBlock;

   sem_t BufferSemaphore;


   SaveBlock *pc_SaveBlocks[SAVEBLOCKARRAYSIZE];
}; // SaveBlockArray

#endif // _SAVEBLOCK_CLASS_LOADED


