// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the Peter Jodda license:
// Everyboy may use it on his own risk. This header must stay in the file!
// If you expand this file, please contact me, that I can integrate the
// enhancemants in the original file.
//

#include "settingsbox.h"
#include <qdialog.h>
#include <qpushbutton.h>
#include <qgrid.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qfiledialog.h>
#include <qdir.h>
#include "hdclient.h"

#include <stdio.h>

#include <sys/ioctl.h>
#include <linux/soundcard.h>

//-----------------------------------------------------------------------------

SettingsBox::SettingsBox(QWidget *parent,
                        HdClient *theApplication) : 
		QDialog(parent,"Settings",TRUE)
{
   QPushButton  *CloseButton;
   QPushButton  *CancelButton;
   QBoxLayout   *topLayout;
   QGridLayout  *grid;
   QBoxLayout   *dialogButtons;
   char          c_Buffer[50];

   p_TheApplication = theApplication;

   topLayout = new QVBoxLayout( this, 2 );


   // set the titel 
   setCaption("KHdClient Settings");


   grid = new QGridLayout( topLayout, 4, 2, 10 );

   m_SoundDeviceEdit = new QLineEdit(this);
   grid->addWidget(new QLabel("Sound Device",this),0,0);
   grid->addWidget(m_SoundDeviceEdit,0,1);

   m_MixerDeviceEdit = new QLineEdit(this);
   grid->addWidget(new QLabel("Mixer Device",this),1,0);
   grid->addWidget(m_MixerDeviceEdit,1,1);


   m_IPAddressEdit = new QLineEdit(this);
   grid->addWidget(new QLabel("IP Address",this),2,0);
   grid->addWidget(m_IPAddressEdit,2,1);

   m_IPPortEdit = new QLineEdit(this);
   grid->addWidget(new QLabel("IP Port",this),3,0);
   grid->addWidget(m_IPPortEdit,3,1);


   // --- the cancel and ok buttons
   dialogButtons = new QHBoxLayout( topLayout);

   CancelButton = new QPushButton( "Cancel", this );
   //cancel->setGeometry( 10,60, 100,30 );
   connect( CancelButton, SIGNAL(clicked()), SLOT(reject()) );


   CloseButton = new QPushButton( "OK", this );
   connect( CloseButton, SIGNAL(clicked()), SLOT(ClosePressed()) );

   dialogButtons->addWidget(CloseButton);   
   dialogButtons->addWidget(CancelButton);   

   
   // set the device names into the edit fields
   m_SoundDeviceEdit->setText(p_TheApplication->m_qs_SoundDevice);
   m_MixerDeviceEdit->setText(p_TheApplication->m_qs_MixerDevice);

   m_IPAddressEdit->setText(p_TheApplication->m_qs_IPAddress);
   sprintf(c_Buffer,"%d",p_TheApplication->m_i_IPPort);
   m_IPPortEdit->setText(c_Buffer);

} // SettingsBox() constructor

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

void SettingsBox::ClosePressed()
{
   QString cs_Port;
   int     i_PortNumber;
   int     i_ScanfResult;
   
   
   p_TheApplication->m_qs_SoundDevice = m_SoundDeviceEdit->text();
   p_TheApplication->m_qs_MixerDevice = m_MixerDeviceEdit->text();
   
   p_TheApplication->m_qs_IPAddress   = m_IPAddressEdit->text();
  
   cs_Port = m_IPPortEdit->text();
   i_ScanfResult = sscanf(cs_Port,"%d",&i_PortNumber);
   if(i_ScanfResult>0)
   {
      p_TheApplication->m_i_IPPort = i_PortNumber;
   }
   

   // apply the mixer setting to the mixer device
   p_TheApplication ->SetOutputMixer();
   
   
   // finish the dialog
   accept();
} // ClosePressed()

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------



